HDU 5380 Travel with candy (单调队列&贪心)

本文纯属原创,转载请注明出处。http://blog.csdn.net/zip_fan,谢谢。

题目传送门:http://acm.hdu.edu.cn/showproblem.php?pid=5380

Travel with candy

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)

Problem Description

There are n+1 cities on a line. They are labeled from city 0 to city n. Mph has to start his travel from city 0, passing city 1,2,3...n-1 in order and finally arrive city n. The distance between city i and city 0 is ai.
Mph loves candies and when he travels one unit of distance, he should eat one unit of candy. Luckily, there are candy shops in the city and there are infinite candies in these shops. The price of buying and selling candies in city i is buyi and selli per
unit respectively. Mph can carry at most C unit of candies.

Now, Mph want you to calculate the minimum cost in his travel plan.

Input

There are multiple test cases.

The first line has a number T, representing the number of test cases.

For each test :

The first line contains two numbers N and C (N≤2×105,C≤106)

The second line contains N numbers a1,a2,...,an.
It is guaranteed that ai>ai?1 for
each 1<i<=N .

Next N+1 line
: the i-th line contains two numbers buyi?1 and selli?1 respectively.
(selli?1≤buyi?1≤106)

The sum of N in
each test is less than 3×105.

Output

Each test case outputs a single number representing your answer.(Note: the answer can be a negative number)

Sample Input

1
4 9
6 7 13 18
10 7
8 4
3 2
5 4
5 4

Sample Output

105

题意:一条直线上从左至右依次排着0-n号一共n+1个城市,XX要从第0个城市到第n个城市去。现在告诉每个城市到第0号城市的距离。已知XX每走一单位长度的距离就会吃掉一颗糖,XX身上最多带m颗糖,每个城市都有糖果店,XX可以在路上根据当前城市的糖果店的买入卖出价格进行补充口袋和卖出糖果赚钱。那么现在问题来了,它这么从0点走到n点,不走回头路,最少要花费多少钱?(如果最后赚钱了,输出就是负的)

出题人保证了m大于等于任意两个相邻的城市之间的距离。

思路:

1、在路上消耗的糖果一定是尽量最便宜的。

2、其它的部分我们可以带着准备卖。

那么每次离开一个点的时候,我们都把口袋补充满。

那么每次到达一个点的时候,我们口袋里都会剩下路途消耗之后的糖果。

此时:

1、口袋里那些购买价格高于当前点购买价格的糖果,我们可以当它们没有被买过,直接以买入价卖出就好。

2、口袋里那些购买价格低于当前点卖出价格的糖果,我们可以当它们有3种用途,第一种是后面被优先消耗了,第二种是在价格更高的点卖出了,第三种是到了最后剩下了。前两种可以忽视掉当前点,第三种则相当于这些糖果在这个点卖出了。那么我们就可以看做这些糖果在这个点就被卖出了,那么它们的买入价就可以看做这个点的卖出价。

或者换句话说,我买入了一个糖果,它的价值就是买入价,如果我带着它到了一个卖出价更高的地方,那么它的价值就成了卖出价。在路上我只消耗当前价值最低的糖果,如果一个糖果到了最后我都没有吃的话,那么就意味着我可以在它价值最高的地方把它卖掉。

下面贴代码。

#include <cstdio>
#include <cmath>
#include <cstring>
#include <string>
#include <map>
#include <queue>
#include <vector>
#include <iostream>
#include <algorithm>
#define moo 1000000007//10^9+7
#define PI acos(-1.0)
#define eps 1e-5
using namespace std;
struct City
{
    int dis;
    int buy;
    int sel;
}a[200005];
struct Queue
{
    int num;
    int val;
}que[200005];
int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        int n,m;
        scanf("%d%d",&n,&m);
        a[0].dis=a[1].dis=0;
        for(int i=2;i<=n+1;i++)
            scanf("%d",&a[i].dis);
        for(int i=1;i<=n+1;i++)
            scanf("%d%d",&a[i].buy,&a[i].sel);
        //以1号点为起点,n+1号点为终点,0号点的距离置0是为了起点不用单独拿出来讨论,节约代码。
        long long ans=0;
        int he=0;
        int en=0;//单调队列维护口袋里的糖果。
        int sum=0;//存的当前口袋里的糖果总量
        for(int i=1;i<=n+1;i++)
        {
            int dis=a[i].dis-a[i-1].dis;
            sum-=dis;//每到一个点,首先消耗dis个
            while(dis!=0)
            {
                if(que[he+1].num<=dis)
                {
                    dis-=que[he+1].num;
                    he++;
                }
                else
                {
                    que[he+1].num-=dis;
                    dis=0;
                }
            }//从队列头开始吃掉dis个糖果

            //将口袋里价值低于当前点出售价格的糖果价值更新为当前点的出售价格
            for(int j=he+1;j<=en;j++)
                if(que[j].val<a[i].sel)
                    que[j].val=a[i].sel;

            //将口袋里价值高于当前点购买价格的糖果按它们最高价值卖掉。
            while(en>he&&que[en].val>a[i].buy)
            {
                ans-=(long long)que[en].val*que[en].num;
                sum-=que[en].num;
                en--;
            }

            //离开该点前,将口袋补充满
            if(sum!=m)
            {
                en++;
                que[en].num=m-sum;
                que[en].val=a[i].buy;
                ans+=(long long)que[en].num*que[en].val;
                sum=m;
            }
        }
        //将最后剩下的糖果按照它们的最高价值卖掉
        while(he!=en)
        {
            ans-=(long long)que[he+1].num*que[he+1].val;
            he++;
        }
        cout<<ans<<endl;
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-11-09 03:34:51

HDU 5380 Travel with candy (单调队列&贪心)的相关文章

HDU 5380 Travel with candy 单调队列

链接 题解链接:http://www.cygmasot.com/index.php/2015/08/16/hdu_5380 题意: n C 一条数轴上有n+1个加油站,起点在0,终点在n.车的油箱容量为C 下面n个数字表示每个加油站距离起点的距离. 下面n+1行表示每个加油站买进和卖出一单位油的价格.油可以买也可以卖. 问开到终点的最小花费. 思路: 把油箱保持装满,然后维护一个价格单调递增的队列. #pragma comment(linker, "/STACK:1024000000,10240

hdu 5380 Travel with candy(双端队列)

题目链接:hdu 5380 Travel with candy 保持油箱一直处于满的状态,维护一个队列,记录当前C的油量中分别可以以多少价格退货,以及可以推货的量.每到一个位置,可以该商店的sell值更新队列中所有价格小于sell的(还没有卖).用buy值更新队列中大于buy(卖掉了).移动所消耗的油从价格最低的开始. #include <cstdio> #include <cstring> #include <algorithm> using namespace st

HDU - 5380 Travel with candy (看题解)

HDU - 5380 感觉又是个脑洞题. 如果没有卖的情况感觉写过很多次了. 这题的关键在于你买糖的消耗只在加入队列的时候计算, 用不完的糖在最后退掉, 卖糖的盈利也包含在最后退糖中了, 我们只要把所有比当前sell值小的全部边成当前的sell值就行了, 相当于卖掉了. 感觉相当巧妙. #include<bits/stdc++.h> #define LL long long #define LD long double #define ull unsigned long long #defin

HDU Non-negative Partial Sums (单调队列)

Problem Description You are given a sequence of n numbers a0,..., an-1. A cyclic shift by k positions (0<=k<=n-1) results in the following sequence: ak ak+1,..., an-1, a0, a1,..., ak-1. How many of the n cyclic shifts satisfy the condition that the

hdu 2191 (多重背包的单调队列优化)

多重背包单调队列优化是思想是.普通的dp为 dp[i][j]=max{dp[i-1][j-k*v[i]]+k*w[i]}; 其实你可以发现对能更新j是j和一个剩余类.也就是 0, v[i],2v[i],3v[i] ,4v[i]... 1 ,1+v[i],1+2v[i],1+3v[i] ........... v[i]-1,2*v[i]-1...... 更新值存在一个剩余类中,组与组之间不存在更新.那么实际上我们可以写dp写好这样 dp[b+x*v[i]]=max{ dp[b+k*v[i]]+(x

hdu 5945 Fxx and game 单调队列优化dp

Fxx and game Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others) Problem Description Young theoretical computer scientist Fxx designed a game for his students. In each game, you will get three integers X,k,t.In each s

cf319b Psychos in a Line(单调队列 贪心)

#include<cstdio> #include<cstdlib> #include<cstring> #include<iostream> #include<algorithm> #include<cmath> using namespace std; #define MAXN 100000+10 int n,st[MAXN],cnt,a[MAXN],kill[MAXN]={0},f[MAXN]={0}; int main() {

HDU 6047 Maximum Sequence (贪心+单调队列)

题意:给定一个序列,让你构造出一个序列,满足条件,且最大.条件是 选取一个ai <= max{a[b[j], j]-j} 析:贪心,贪心策略就是先尽量产生大的,所以就是对于B序列尽量从头开始,由于数据比较大,采用桶排序,然后维护一个单调队列,使得最头上最大. 代码如下: #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include <string> #i

HDU 4122 Alice&#39;s mooncake shop 单调队列优化dp

Alice's mooncake shop Time Limit: 20 Sec Memory Limit: 256 MB 题目连接 http://acm.hdu.edu.cn/showproblem.php?pid=4122 Description The Mid-Autumn Festival, also known as the Moon Festival or Zhongqiu Festival is a popular harvest festival celebrated by Ch